summaryrefslogtreecommitdiffstats
path: root/heat/ONAP/cloud-config/dcae2_install.sh
diff options
context:
space:
mode:
authorGary Wu <gary.i.wu@huawei.com>2018-08-02 12:04:01 -0700
committerGary Wu <gary.i.wu@huawei.com>2018-08-02 14:10:08 -0700
commit16509432a21feb3f90bbf954ec4815c2bf7f0033 (patch)
treef41f14f1102c7eeddbf3c0509bf9d69ce18818e4 /heat/ONAP/cloud-config/dcae2_install.sh
parent3ddd88cf4cb92f5b8e0eebca9afe806f96a09fba (diff)
Refactor ONAP HEAT template config scripts
Change-Id: I5f95acc7c67d48ea1f7f9e819d6c9e742e4b52cc Issue-ID: INT-605 Signed-off-by: Gary Wu <gary.i.wu@huawei.com>
Diffstat (limited to 'heat/ONAP/cloud-config/dcae2_install.sh')
-rwxr-xr-xheat/ONAP/cloud-config/dcae2_install.sh115
1 files changed, 115 insertions, 0 deletions
diff --git a/heat/ONAP/cloud-config/dcae2_install.sh b/heat/ONAP/cloud-config/dcae2_install.sh
new file mode 100755
index 00000000..d0f5fd6e
--- /dev/null
+++ b/heat/ONAP/cloud-config/dcae2_install.sh
@@ -0,0 +1,115 @@
+#!/bin/bash
+#############################################################################
+#
+# Copyright (c) 2017 AT&T Intellectual Property. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+#############################################################################
+
+set -ex
+
+# Read configuration files
+ARTIFACTS_VERSION=$(cat /opt/config/artifacts_version.txt)
+DNS_IP_ADDR=$(cat /opt/config/dns_ip_addr.txt)
+CLOUD_ENV=$(cat /opt/config/cloud_env.txt)
+EXTERNAL_DNS=$(cat /opt/config/external_dns.txt)
+MAC_ADDR=$(cat /opt/config/mac_addr.txt)
+HTTP_PROXY=$(cat /opt/config/http_proxy.txt)
+HTTPS_PROXY=$(cat /opt/config/https_proxy.txt)
+
+if [ $HTTP_PROXY != "no_proxy" ]
+then
+ export http_proxy=$HTTP_PROXY
+ export https_proxy=$HTTPS_PROXY
+fi
+
+MTU=$(/sbin/ifconfig | grep MTU | sed 's/.*MTU://' | sed 's/ .*//' | sort -n | head -1)
+
+if [[ $CLOUD_ENV != "rackspace" ]]
+then
+ # Add host name to /etc/host to avoid warnings in openstack images
+ echo "127.0.0.1 $(hostname)" >> /etc/hosts
+
+ # Allow remote login as root
+ mv /root/.ssh/authorized_keys /root/.ssh/authorized_keys.bk
+ cp /home/ubuntu/.ssh/authorized_keys /root/.ssh
+fi
+
+# Download dependencies
+apt-get update
+#apt-get install -y apt-transport-https ca-certificates wget make git ntp ntpdate python python-pip
+apt-get install -y apt-transport-https ca-certificates wget git ntp ntpdate python python-pip
+
+# Download scripts from Nexus
+unzip -p -j /opt/boot-$ARTIFACTS_VERSION.zip dcae2_vm_init.sh > /opt/dcae2_vm_init.sh
+unzip -p -j /opt/boot-$ARTIFACTS_VERSION.zip serv.sh > /opt/dcae2_serv.sh
+unzip -p -j /opt/boot-$ARTIFACTS_VERSION.zip imagetest.sh > /opt/imagetest.sh
+chmod +x /opt/imagetest.sh
+chmod +x /opt/dcae2_vm_init.sh
+chmod +x /opt/dcae2_serv.sh
+sed -i "s|cmd=\"\"|cmd=\"./dcae2_vm_init.sh\"|g" /opt/dcae2_serv.sh
+mv /opt/dcae2_serv.sh /etc/init.d
+update-rc.d dcae2_serv.sh defaults
+
+# Download and install docker-engine and docker-compose
+echo "deb https://apt.dockerproject.org/repo ubuntu-$(lsb_release -cs) main" | sudo tee /etc/apt/sources.list.d/docker.list
+apt-get update
+apt-get install -y "linux-image-extra-$(uname -r)" linux-image-extra-virtual jq
+apt-get install -y --allow-unauthenticated docker-engine
+
+mkdir -p /opt/docker
+curl -L "https://github.com/docker/compose/releases/download/1.9.0/docker-compose-$(uname -s)-$(uname -m)" > /opt/docker/docker-compose
+chmod +x /opt/docker/docker-compose
+
+# Set the MTU size of docker containers to the minimum MTU size supported by vNICs. OpenStack deployments may
+# need to know the external DNS IP
+DNS_FLAG=""
+if [ -s /opt/config/dns_ip_addr.txt ]
+then
+ DNS_FLAG=$DNS_FLAG"--dns $(cat /opt/config/dns_ip_addr.txt) "
+fi
+if [ -s /opt/config/external_dns.txt ]
+then
+ DNS_FLAG=$DNS_FLAG"--dns $(cat /opt/config/external_dns.txt) "
+fi
+echo "DOCKER_OPTS=\"$DNS_FLAG--mtu=$MTU --raw-logs -H tcp://0.0.0.0:2376 -H unix:///var/run/docker.sock\"" >> /etc/default/docker
+
+cp /lib/systemd/system/docker.service /etc/systemd/system
+sed -i "/ExecStart/s/$/ --mtu=$MTU/g" /etc/systemd/system/docker.service
+sed -i "/ExecStart/s/$/ -H tcp:\/\/0.0.0.0:2376 --raw-logs/g" /etc/systemd/system/docker.service
+if [ $HTTP_PROXY != "no_proxy" ]
+then
+cd /opt
+./imagetest.sh
+fi
+systemctl daemon-reload
+service docker restart
+
+# add hostname aliases
+echo "$(cat /opt/config/dcae_ip_addr.txt) consul" >>/etc/hosts
+echo "$(cat /opt/config/dcae_ip_addr.txt) dockerhost" >>/etc/hosts
+
+# DNS IP address configuration
+echo "nameserver $DNS_IP_ADDR" >> /etc/resolvconf/resolv.conf.d/head
+resolvconf -u
+
+# prepare the configurations needed by DCAEGEN2 installer
+rm -rf /opt/app/config
+mkdir -p /opt/app/config
+
+# private key
+sed -e 's/\\n/\n/g' /opt/config/priv_key | sed -e 's/^[ \t]*//g; s/[ \t]*$//g' > /opt/app/config/key
+chmod 777 /opt/app/config/key
+
+cd /opt
+./dcae2_vm_init.sh